﻿using System;
using System.Collections.ObjectModel;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SilverlightApplication2
{
    public class CustomerCollection : ObservableCollection<Customer>
    {

    }

    public class StreamCollection : ObservableCollection<Stream>
    {
        public new void Add(Stream item)
        {
            item.PropertyChanged += item_PropertyChanged;
            base.Add(item);
        }

        public void AddWithParent(Stream item, Customer parent)
        {
            Add(item);
            item.Parent = parent;
        }


        private void item_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "Selected")
                (sender as Stream).Parent.ComputeChildrenCount();
        }

        protected override void RemoveItem(int index)
        {
            var i = this[index];
            base.RemoveItem(index);
            if (i == null) return;
            i.PropertyChanged -= item_PropertyChanged;
            i.Parent = null;
        }

        protected override void InsertItem(int index, Stream item)
        {
            base.InsertItem(index,item);
            item.PropertyChanged += item_PropertyChanged;
        }

        protected override void ClearItems()
        {
            foreach (var stream in Items)
            {
                stream.PropertyChanged -= item_PropertyChanged;
                stream.Parent = null;
            }
        }
    }
}
