﻿using System;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SilverlightApplication2
{
    public class Customer : TreeBase
    {

        private bool allStreamsAllowed;
        public bool AllStreamsAllowed
        {
            get { return allStreamsAllowed; }
            set
            {   if (value==allStreamsAllowed) return;
                allStreamsAllowed = value;
                foreach (var s in streams)
                {
                    s.Selected = false;
                    s.IsEnabled = !allStreamsAllowed;
                }
                ComputeChildrenCount();
                OnPropertyChanged("AllStreamsAllowed");
            }
        }

        public int ActiveStreamsCount { get ; set; }
        public int TotalStreamsCount { get; set; }

        private readonly StreamCollection streams = new StreamCollection();
        public StreamCollection Streams
        {
            get { return streams; }
        }

        public void ComputeChildrenCount()
        {
            ActiveStreamsCount = (from s in streams where s.Selected select s).Count();
            TotalStreamsCount = streams.Count;
            OnPropertyChanged("ActiveStreamsCount");
            OnPropertyChanged("TotalStreamsCount");
            OnPropertyChanged("ShowCount");
            OnPropertyChanged("ShowAlert");
        }

        public Customer()
        {
            streams.CollectionChanged += streams_CollectionChanged;
        }

        private void streams_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            ComputeChildrenCount();
        }

        public bool ShowCount
        {
            get { return !AllStreamsAllowed && !ShowAlert; }
        }

        public bool ShowAlert
        {
            get { return !AllStreamsAllowed && ActiveStreamsCount == 0; }
        }
    }
}
