﻿using System;
using System.ComponentModel;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SilverlightApplication2
{
    public class Stream : TreeBase
    {
        private Customer parent;
        public Customer Parent
        {
            get { return parent; }
            set
            {
                if (parent == value) return;
                if (parent != null) parent.PropertyChanged -= parent_PropertyChanged;
                parent = value;
                if (parent != null) Parent.PropertyChanged += parent_PropertyChanged;
                IsEnabled = parent!=null && !Parent.AllStreamsAllowed;
                OnPropertyChanged("Parent");
            }
        }

        private bool isEnabled;
        public bool IsEnabled
        {
            get { return isEnabled; }
            set
            {
                if (value == isEnabled) return;
                isEnabled = value;
                OnPropertyChanged("IsEnabled");
            }
        }

        private bool _Selected;
        public bool Selected
        {
            get { return _Selected; }
            set
            {
                if (_Selected == value) return;
                _Selected = value;
                OnPropertyChanged("Selected");
            }
        }

        private void parent_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "Selected")
                foreach (var s in parent.Streams) s.IsEnabled = !parent.AllStreamsAllowed;
        }
    }
}
