using System;
using System.ComponentModel;

namespace SilverlightApplication2
{
    public abstract class TreeBase : INotifyPropertyChanged
    {
        private string name;
        public event PropertyChangedEventHandler PropertyChanged;

        public String Name
        {
            get { return name; }
            set
            {
                if (value == name) return;
                name = value;
                OnPropertyChanged("Name");
            }
        }

        protected void OnPropertyChanged(string property)
        {
            var p = PropertyChanged;
            if (p == null) return;
            p(this, new PropertyChangedEventArgs(property));
        }
    }
}